<div align="center">

# docsify-select

[![GitHub Release](https://img.shields.io/github/release/jthegedus/docsify-select.svg)](https://github.com/jthegedus/docsify-select/releases) [![NPM Release](https://img.shields.io/npm/v/docsify-select.svg)](https://www.npmjs.com/package/docsify-select) ![Lint and Unit Tests](https://github.com/jthegedus/docsify-select/workflows/Lint%20and%20Unit%20Tests/badge.svg) [![CodeQL](https://github.com/jthegedus/docsify-select/actions/workflows/codeql-analysis.yml/badge.svg)](https://github.com/jthegedus/docsify-select/actions/workflows/codeql-analysis.yml)

A [docsify.js](https://docsify.js.org) plugin for variably rendering content with HTML select menus defined in markdown.

</div>

## Features

- Single select menus
- Multi select menus
- Complex multi-select menus with partial selections and default content
- Sync selection across menus with same id
- Automatically detect operating system and select options for menus with specific labels
- Compatible with [`docsify-tabs`](https://github.com/jhildenbiddle/docsify-tabs)

## [Documentation & Demos](https://jthegedus.github.io/docsify-select/)

![docsify select demo](docs/assets/images/docsify-select-demo.gif "docsify select demo")

## Credit

Adapted from [jhildenbiddle's](https://github.com/jhildenbiddle/) `docsify-tabs` plugin, so many thanks to them.

## Contributing

Contributions of any kind welcome, just [follow the guidelines](contributing.md)!

### Contributors

Thanks goes to [these contributors](https://github.com/jthegedus/docsify-select/graphs/contributors)!

## License

[MIT License](LICENSE)
